love.window.setMode(0,0,{fullscreen=borderless})
Timer = require 'Libraries/hump/timer'
require 'colors'
function love.load()
	Font = love.graphics.newFont("Arimo/Arimo-Regular.ttf",30) --descrivbwe font
	love.graphics.setFont(Font) --set font
	textspeed = 0.00025 --every __ seconds, add a character
	timer = Timer()
	
	textcolor = White
	currenttext = "" --empty string
	se1 = love.audio.newSource("hitsound.wav","static") --sound that plays when non space character is placed
	place = 0 --what width in the box are we currently in
	curline = 1 -- what height in the box are we currently in?
	status = "in_progress" --status of placing charachters
	box = { --the box the text is drawn in
		lines = 4, -- how many lines of text?
		width = 1840, 
		x = 0,
		y = 0
	}
	box.x = (love.graphics.getWidth()-box.width)/2 --calculate box.x outside of box{} because it calls box.width. 
	box.y = love.graphics.getHeight()-Font:getHeight()*box.lines - 5 


	text("Lorem ipsum dolor sit amet,<Red> consectetur adipiscing elit<White>. Sed arcu <Red>augue<White>, molestie sed volutpat ac, rutrum in quam. Nunc vel iaculis odio, quis dapibus purus. Praesent tortor sapien, congue sed ullamcorper id, maximus sed enim. Aliquam mollis venenatis maximus. Vestibulum in convallis eros. Nam eu eros ullamcorper, gravida ipsum nec, tincidunt justo. Suspendisse ultricies erat et leo vestibulum, varius convallis magna interdum. Nullam convallis convallis est vel pretium. Vestibulum euismod malesuada ligula eget ornare.Phasellus tempor nibh quis metus vestibulum finibus. Aenean sed accumsan velit, suscipit scelerisque eros. Donec magna dolor, eleifend ut pharetra sollicitudin, volutpat vel dolor. Nulla semper fringilla justo et tincidunt. Duis malesuada diam quis nisl mattis iaculis. Nunc lorem ante, ultrices nec pretium ultrices, scelerisque quis ligula. Nullam diam neque, condimentum a lorem nec, volutpat tincidunt leo. Integer tincidunt finibus ante sed fermentumf")
end

function love.update(dt)
	timer:update(dt)
end

function love.draw()
	love.graphics.setColor(0.25,0.25,0.67) -- set color to black
	love.graphics.rectangle("fill",box.x-13,box.y,box.width,Font:getHeight()*box.lines,15,15,3) -- this box is drawn first, so everything else is drawn over it. It makes the background of the box non transparent
	love.graphics.setColor(textcolor) --set color to white
	love.graphics.print(currenttext,box.x,box.y)--draw the actual text
	love.graphics.setColor(White)
	love.graphics.setLineWidth(1.5) --thicker line
	love.graphics.rectangle("line",box.x-13,box.y,box.width,Font:getHeight()*box.lines,15,15,3) --draw the box
	love.graphics.setLineWidth(1) --regular line
end

function text(text)
	local chars = {} --empty table. will be filled with individual charachters from (text)
	text:gsub(".",function(c) table.insert(chars,c) end) --fill table as described above
	textimer = timer:every(textspeed,function() --the timer. calls this function every textspeed of a second
		
		if chars[1] == "<" then --if the beginning of a tag
			textcolor = "" -- the color is blank
			table.remove(chars,1) --remove tag beginning 
			while chars[1] ~= ">" do --while the tag is still going on
				textcolor = textcolor .. chars[1] --the current character is added to the textcolor
				table.remove(chars,1) --and then removed from the table.
			end
			table.remove(chars,1)--this only executes once the tag is finished, because of the while function
			textcolor = _G[textcolor] --this turns the string into a variable to work with setColor
		end







		
		if chars[1] then --if there is text that needs drawing
			place = place + Font:getWidth(chars[1])  --the width we are at increases by the fonts width

			




			if status == "in_progress" then --if in progress
				if chars[1] ~= " " then --if the charachter is not a space
					se1:play()	--play sound
				end
				currenttext = currenttext .. chars[1] --concentrate the text being drawn with the current char. "a" .. "b" would make "ab"
				table.remove(chars,1) --now that character is added, remove it from the list so we can draw the next one
			end

			if place > box.width - 25 then --if we are going out of the box's boundry
				if curline == box.lines then --if the box is filled
					
					if status == "finished" then --if we are finished
						curline = 0 --reset varaibles to prepare for next text()
						status = "in_progress" 
						currenttext = ""
						place = 0	
					else --if not finished but box is filled
						status = "waiting" --wait for the player to hit space
					end
				else 
					curline = curline + 1 --if not filled yet
					currenttext = currenttext .. "\n" --go to next line
					place = 0	--start a beginning of next line
				end
			end
		else
			if status == "finished" then --if everything is done
				Timer:cancel(textimer) --delete timer so it doesn't use up memory
				curline = 0 --reset vars
				status = "in_progress" 
				place = 0
				currenttext = ""
			end
			status = "waiting" --wait for player to clear
		end
	end)
end

function love.keypressed(key)
	if key == "space" and status == "waiting" then --if we are waiting for player, and the player presses space, go to next box
		status = "finished"
	end
end